"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var parse_exports = {};
__export(parse_exports, {
  ParsedError: () => ParsedError,
  getErrorCause: () => getErrorCause
});
module.exports = __toCommonJS(parse_exports);
var import_assert = __toESM(require("assert"));
var import_util = require("util");
var import_lodash = __toESM(require("@modern-js/utils/lodash"));
var import_stacktracey = __toESM(require("../../compiled/stacktracey"));
var import_utils = require("../shared/utils");
var import_context = require("./context");
const getErrorCause = (error) => {
  (0, import_assert.default)(typeof error === "object", "Error must be an object");
  const err = error;
  return [
    err.cause,
    err.error,
    err.originalError
  ].find(import_lodash.default.isError);
};
class ParsedError {
  [import_util.inspect.custom]() {
    const formatted = (0, import_utils.formatError)(this.context.formatters, this);
    return formatted;
  }
  freeze() {
    const ret = {
      ...this,
      [import_util.inspect.custom]: import_lodash.default.constant((0, import_util.inspect)(this))
    };
    return Object.freeze(ret);
  }
  constructor(error, context = new import_context.Context()) {
    this.type = "error";
    this.causes = [];
    this.trace = [];
    this.raw = error;
    var _this_raw_name;
    this.name = (_this_raw_name = this.raw.name) !== null && _this_raw_name !== void 0 ? _this_raw_name : "Error";
    var _this_raw_message;
    this.message = (_this_raw_message = this.raw.message) !== null && _this_raw_message !== void 0 ? _this_raw_message : "";
    this.context = context;
    if (context.withSources) {
      this.trace = new import_stacktracey.default(error).withSources().items;
    } else {
      this.trace = new import_stacktracey.default(error).items;
    }
    const rawCause = getErrorCause(this.raw);
    if (rawCause) {
      this.cause = new ParsedError(rawCause);
      this.cause.parent = this;
      this.causes.push(this.cause, ...this.cause.causes);
    }
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ParsedError,
  getErrorCause
});
