"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var plugin_exports = {};
__export(plugin_exports, {
  FriendlyErrorsWebpackPlugin: () => FriendlyErrorsWebpackPlugin
});
module.exports = __toCommonJS(plugin_exports);
var import_output = require("./core/output");
class FriendlyErrorsWebpackPlugin {
  apply(compiler) {
    compiler.hooks.done.tapPromise(this.name, async (stats) => {
      {
        const opts = {
          ...this.options,
          type: "warning"
        };
        const warnings = stats.compilation.getWarnings();
        for (const warning of warnings) {
          (0, import_output.outputPrettyError)(warning, opts);
        }
      }
      {
        const opts = {
          ...this.options,
          type: "error"
        };
        const errors = stats.compilation.getErrors();
        for (const error of errors) {
          (0, import_output.outputPrettyError)(error, opts);
        }
      }
    });
  }
  constructor(options) {
    this.name = "FriendlyErrorsWebpackPlugin";
    this.options = options !== null && options !== void 0 ? options : {};
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  FriendlyErrorsWebpackPlugin
});
